# zope imports
from zope.interface import Interface
from zope.interface import implements
from zope.i18nmessageid import MessageFactory
_ = MessageFactory("iqpp.commenting")

# Five imports
from Products.Five.browser import pagetemplatefile
from Products.Five.browser import BrowserView

# CMFCore imports
from Products.CMFCore.utils import getToolByName

class IConfigletForm(Interface):
    """
    """
    def save():
        """Saves configlet form to commenting form.
        """
    
    def getOptions():
        """Returns all options as a dict.
        """    
        
class ConfigletForm(BrowserView):
    """
    """
    implements(IConfigletForm)        

    def save(self):
        """
        """        
        ctool = getToolByName(self.context, "commenting_tool")                        
        ctool.manage_changeProperties(
            is_moderated = self.request.get("is_moderated"),
            show_preview = self.request.get("show_preview"),
            time_to_edit = self.request.get("time_to_edit"),
        )

        utils = getToolByName(self.context, "plone_utils")
        utils.addPortalMessage(_("Commenting settings updated."))
        
        url = self.request.get("HTTP_REFERER")
        self.request.response.redirect(url)
        
    def getOptions(self):
        """
        """
        ctool = getToolByName(self.context, "commenting_tool")
        return dict(ctool.propertyItems())
