# Zope imports
from AccessControl import Unauthorized

# zope imports
from zope.interface import directlyProvides
from zope.component import provideUtility, queryUtility
from zope.component import getMultiAdapter

# test imports
from base import CommentingTestCase

# iqpp.rating imports
from iqpp.commenting.interfaces import ICommenting

class TestPortlets(CommentingTestCase):

    def afterSetUp(self):
        self.setRoles(("Manager",))        
        # for some reason, metadata isn't added via zcml
        self.portal.portal_catalog.manage_addColumn("comments")
                
        self.portal.invokeFactory("Document", "document")
        self.d = self.portal.document        
        
    def testPendingComments(self):
        """
        """
        manager = ICommenting(self.d)
        view = getMultiAdapter((self.d, self.d.REQUEST), name="reviewCommentsView")
                
        new_id = manager.addComment(
                    reply_to = "", 
                    subject = "My Subject", 
                    message = "My Message", 
                    name="John Doe")

        new_id = manager.addComment(
                    reply_to = "", 
                    subject = "My Subject", 
                    message = "My Message", 
                    name="John Doe")
    
        comments = view.getPendingComments()
        self.assertEqual(len(comments), 2)
        
        manager.editComment(
            comment_id = new_id,
            reply_to = "",
            subject  = "Modified Subject",
            message  = "Modified Message",
            name     = "Jane Doe",
            member_id = "",
            email = "",
            review_state="public")

        comments = view.getPendingComments()        
        self.assertEqual(len(comments), 1)
                                
def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestPortlets))        
    return suite
