from Globals import InitializeClass
from OFS.Folder import Folder 
from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.CMFCore.utils import UniqueObject   
from Products.EasyCommenting.config import *

class CommentingTool(UniqueObject, Folder):
    """A tool to administrate sidewide commenting parameters 
    """
    id = 'commenting_tool'
    meta_type= 'Commenting Tool'

    security = ClassSecurityInfo()

    _properties=({'id':'show_preview', 'type': 'boolean', 'mode': 'w'},                                      
                 {'id':'is_moderated', 'type': 'boolean', 'mode': 'w'},
                 {'id':'time_to_edit', 'type': 'int', 'mode': 'w'},
                )
    
    def __init__(self, id=None):
        self.show_preview = False
        self.is_moderated = False   
        self.time_to_edit = 60     
        
InitializeClass(CommentingTool)
