# zope imports
from zope.interface import Interface

class IAddCommentView(Interface):    
    """
    """
    def addComment():
        """Adds a comment.
        """    

    def getErrors():
        """Returns validation errors.
        """

    def getFieldValues():
        """Returns all field values as a dict.
        """

    def getOptions():
        """Returns all options as a dict.
        """
        
    def isMember():
        """Returns True if an authenticated member is commenting.
        """

    def redirect():
        """Redirects after a comment was edited/added. Could be overwritten if
        one wants to combine commenting with some other services, e.g. rating.
        """

    def validate():
        """Validates the form and sets errors if there are some.
        """
        
class ICommentsView(Interface):
    """
    """
    def deleteComments():
        """Deletes all comments.
        """

    def deleteComment(add_message=True, redirect=True):
        """Deletes a comment.
        
        Parameters "add_message" and "redirect" makes it easier to use the 
        commenting for third party products. Developers are able to decide
        to use the internal messages and redirect after a comment has been
        deleted or use its own ones.
        """

    def getComments():
        """Returns direct comments of the object.
        """

    def getCommentForMember(member_id=None):
        """
        """    
        
    def getCommentsForMember(member_id=None):
        """
        """
        
    def showDeleteButton(comment):
        """Returns True if a delete button is supposed to be showed.
        """

    def showEditButton(comment):
        """Returns True if a edit button is supposed to be showed.
        """
    def showManageButton():
        """Returns True if a edit button for manager is supposed to be showed.
        """

class IEditCommentView(Interface):
    """
    """
    def editComment():
        """Updates the data.
        """
    
    def getComment():
        """Returns the comment, which is supposed to be edited as a dict.
        """
    
    def getReviewStates():
        """Returns review states for comments.
        """
                        
class IPreviewCommentView(Interface):
    """"
    """
    def getData():
        """Returns a dict of the entered data. 
        """

class IReviewCommentsView(Interface):
    """Provides methods for reviewing comments
    """
    def getPendingComments():
        """Returns all pending comments.
        """

    def getPendingCommentsForPortlet():
        """Returns a subset of pending comments.
        """