# zope imports
from zope.component.exceptions import ComponentLookupError

# iqpp.commenting imports
from iqpp.commenting.interfaces import ICommenting
from iqpp.commenting.interfaces import ICommentable

# CMFPlone imports
from Products.CMFPlone.CatalogTool import registerIndexableAttribute

def published_comments(object, portal, **kwargs):
    try:
        comments = []
        for comment in ICommenting(object).getAllComments():
            if comment.review_state == "published":
                comments.append(comment.id)
            
        return comments
            
    except (ComponentLookupError, TypeError, ValueError):
        # The catalog expects AttributeErrors when a value can't be found
        raise AttributeError

def pending_comments(object, portal, **kwargs):
    try:
        comments = []
        for comment in ICommenting(object).getAllComments():
            if comment.review_state == "pending":
                comments.append(comment.id)
            
        return comments
            
    except (ComponentLookupError, TypeError, ValueError):
        # The catalog expects AttributeErrors when a value can't be found
        raise AttributeError

def commentable(object, portal, **kwargs):
    try:
        return ICommentable.providedBy(object)
            
    except (ComponentLookupError, TypeError, ValueError):
        # The catalog expects AttributeErrors when a value can't be found
        raise AttributeError

registerIndexableAttribute('published_comments', published_comments)
registerIndexableAttribute('pending_comments', pending_comments)
registerIndexableAttribute('commentable', commentable)